<?php

namespace App\Service;

use App\Model\Measure;

/**
 * 测量相关
 * @package App\Models
 */
class MeasureService extends Service
{
    public function edit($data){
        if($this->isEmpty($data,'id')) return [201,'ID不存在！'];
        list($status,$msg) = $this->rule($data);
        if(!$status) return [$status,$msg];
        $first = Measure::where('title',$data['title'])->where('id','<>',$data['id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Measure();
        $model = $model->where('id',$data['id'])->first();
        $model->title = $data['title'];
        $model->e_title = $data['e_title'] ;

        $model->save();

        return [true,'保存成功！'];
    }

    public function add($data,$user){
        list($status,$msg) = $this->rule($data);
        if(!$status) return [$status,$msg];
        $first = Measure::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Measure();
        $sort = $model->max('sort');

        $model->title = $data['title'];
        $model->e_title = $data['e_title'] ;
        $model->sort = $sort ? $sort + 1 : 1;
        $model->save();

        return [true,'保存成功！'];

    }

    public function del($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        Measure::where('id',$data['id'])->update([
            'del_time'=>time()
        ]);

        return [true,'删除成功'];
    }

    public function measureList($data){
        $list = Measure::where('del_time',0)->select('title','e_title','crt_time','upd_time','id')->orderBy('sort','asc');

        $list = $this->limit($list,'',$data);

        return [200,$list];
    }

    public function rule($data){
        if($this->isEmpty($data,'title')) return [false,'中文名称不存在！'];
        if($this->isEmpty($data,'e_title')) return [false,'英文名称不存在！'];

        return [true,''];
    }




}
