<?php

namespace App\Service;


use App\Model\Depart;
use App\Model\Employee;
use App\Model\EmployeeDepartPermission;
use App\Model\EmployeeMenuPermission;
use App\Model\EmployeeTeamPermission;
use App\Model\Measure;
use App\Model\Product;
use App\Model\ProductDetail;
use App\Model\Role;
use App\Model\SysMenu;
use App\Model\Team;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;

/**
 * 产品相关
 * @package App\Models
 */
class ProductService extends Service
{

    public function edit($data){
        if($this->isEmpty($data,'id')) return [201,'ID不存在！'];
        list($status,$msg) = $this->rule($data);
        if(!$status) return [$status,$msg];
        $first = Product::where('title',$data['title'])->where('id','<>',$data['id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];
        DB::beginTransaction();
        try{

            $model = new Product();
            $model = $model->where('id',$data['id'])->first();
            $model->title = $data['title'];
            $model->unit = $data['unit'] ;
            $model->model = $data['model'] ?? '';
            $model->save();
            $product_id = $model->id;
            $product_detail_insert = [];
            foreach ($data['product_detail'] as $v) {

                $product_detail_insert[] = [
                    'bom_id' => $v['bom_id'],
                    'num' => $v['num'],
                    'product_id' => $product_id,
                ];
            }
            ProductDetail::insert($product_detail_insert);
            DB::commit();
            return [true,'保存成功'];
        }catch (\Exception $e){
            DB::rollBack();
            return [false,$e->getMessage()];
        }



    }

    public function add($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->rule($data);
        if(!$status) return [$status,$msg];
        $first = Product::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];
        DB::beginTransaction();
        try{

            $model = new Product();
            $model->title = $data['title'];
            $model->unit = $data['unit'] ;
            $model->model = $data['model'] ?? '';
            $model->save();
            $product_id = $model->id;
            $product_detail_insert = [];
            foreach ($data['product_detail'] as $v) {

                $product_detail_insert[] = [
                    'bom_id' => $v['bom_id'],
                    'num' => $v['num'],
                    'product_id' => $product_id,
                ];
            }
            ProductDetail::insert($product_detail_insert);
            DB::commit();
            return [true,'保存成功'];
        }catch (\Exception $e){
            DB::rollBack();
            return [false,$e->getMessage()];
        }




    }

    public function del($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        Product::where('id',$data['id'])->update([
            'del_time'=>time()
        ]);

        return [true,'删除成功'];
    }

    public function productList($data){
        $list = Product::where('del_time',0)->select('title','unit','model','crt_time','upd_time','id')->orderBy('sort','asc');

        $list = $this->limit($list,'',$data);

        return [200,$list];
    }

    public function productDetail($data){

        $first = Product::where('del_time',0)->where('id',$data['id'])->select('title','unit','model','crt_time','upd_time','id')->first();

        if(empty($first)) return [false,'err'];



        $first = $first->toArray();
        $first['detail'] = ProductDetail::from('product_detail as pd')
            ->leftJoin('bom as m','m.id','pd.bom_id')
            ->select('title','unit','num')->get()->toArray();
        return [200,$first];
    }

    public function rule($data){
        if($this->isEmpty($data,'title')) return [false,'中文名称不存在！'];
//        if($this->isEmpty($data,'icon')) return [201,'d不存在！'];
        if($this->isEmpty($data,'unit')) return [false,'单位不存在！'];
        if($this->isEmpty($data,'model')) return [false,'型号不存在！'];

        return [true,''];
    }




}
