<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

Route::any('login', 'Api\LoginController@login');
Route::any('loginMobile', 'Api\LoginController@loginMobile');
Route::any('test', 'Api\TestController@aa');
Route::any('getHeaderWord', 'Api\HeaderWordController@getHeaderWord');
Route::any('deviceList', 'Api\Device\DeviceController@deviceList');
Route::group(['middleware'=> []],function ($route){
    $route->any('menuAdd', 'Api\SysMenuController@add');
    $route->any('menuEdit', 'Api\SysMenuController@edit');
    $route->any('menuDel', 'Api\SysMenuController@del');
    $route->any('menuList', 'Api\SysMenuController@menuList');

    $route->any('employeeAdd', 'Api\EmployeeController@employeeAdd');
    $route->any('employeeEdit', 'Api\EmployeeController@employeeEdit');
    $route->any('employeeDel', 'Api\EmployeeController@employeeDel');
    $route->any('employeeList', 'Api\EmployeeController@employeeList');

    $route->any('departAdd', 'Api\EmployeeController@departAdd');
    $route->any('departEdit', 'Api\EmployeeController@departEdit');
    $route->any('departDel', 'Api\EmployeeController@departDel');
    $route->any('departList', 'Api\EmployeeController@departList');


    $route->any('roleAdd', 'Api\EmployeeController@roleAdd');
    $route->any('roleEdit', 'Api\EmployeeController@roleEdit');
    $route->any('roleDel', 'Api\EmployeeController@roleDel');
    $route->any('roleList', 'Api\EmployeeController@roleList');

    $route->any('teamAdd', 'Api\EmployeeController@teamAdd');
    $route->any('teamEdit', 'Api\EmployeeController@teamEdit');
    $route->any('teamDel', 'Api\EmployeeController@teamDel');
    $route->any('teamList', 'Api\EmployeeController@teamList');

    $route->any('employeeDepart', 'Api\EmployeeController@employeeDepart');
    $route->any('employeeTeam', 'Api\EmployeeController@employeeTeam');
    $route->any('employeeRole', 'Api\EmployeeController@employeeRole');

    $route->any('measureAdd', 'Api\MeasureController@Add');
    $route->any('measureEdit', 'Api\MeasureController@Edit');
    $route->any('measureDel', 'Api\MeasureController@Del');
    $route->any('measureList', 'Api\MeasureController@measureList');

    $route->any('basicMaterialList', 'Api\MaterialController@basicMaterialList');
    $route->any('basicMaterialEdit', 'Api\MaterialController@basicMaterialEdit');
    $route->any('basicMaterialAdd', 'Api\MaterialController@basicMaterialAdd');
    $route->any('basicMaterialDel', 'Api\MaterialController@basicMaterialDel');

    $route->any('materialList', 'Api\MaterialController@materialList');
    $route->any('materialDetail', 'Api\MaterialController@materialDetail');
    $route->any('materialEdit', 'Api\MaterialController@materialEdit');
    $route->any('materialAdd', 'Api\MaterialController@materialAdd');
    $route->any('materialDel', 'Api\MaterialController@materialDel');

    //工序
    $route->any('basicProcessList', 'Api\ProcessController@basicProcessList');
    $route->any('basicProcessEdit', 'Api\ProcessController@basicProcessEdit');
    $route->any('basicProcessAdd', 'Api\ProcessController@basicProcessAdd');
    $route->any('basicProcessDel', 'Api\ProcessController@basicProcessDel');

    $route->any('processList', 'Api\ProcessController@processList');
    $route->any('processDetail', 'Api\ProcessController@processDetail');
    $route->any('processEdit', 'Api\ProcessController@processEdit');
    $route->any('processAdd', 'Api\ProcessController@processAdd');
    $route->any('processDel', 'Api\ProcessController@processDel');

    //工艺
    $route->any('technologyList', 'Api\TechnologyController@technologyList');
    $route->any('technologyEdit', 'Api\TechnologyController@technologyEdit');
    $route->any('technologyAdd', 'Api\TechnologyController@technologyAdd');
    $route->any('technologyDel', 'Api\TechnologyController@technologyDel');
    $route->any('technologyCopy', 'Api\TechnologyController@technologyCopy');

    $route->any('productList', 'Api\MaterialController@productList');
    $route->any('productEdit', 'Api\MaterialController@edit');
    $route->any('productAdd', 'Api\MaterialController@edd');
    $route->any('productDel', 'Api\MaterialController@del');

    $route->any('bomList', 'Api\BomController@bomList');
    $route->any('bomDetail', 'Api\BomController@bomDetail');
    $route->any('bomEdit', 'Api\BomController@edit');
    $route->any('bomAdd', 'Api\BomController@add');
    $route->any('bomDel', 'Api\BomController@del');

    $route->any('orderList', 'Api\OrderController@orderList');
    $route->any('orderAdd', 'Api\OrderController@add');
    $route->any('orderEdit', 'Api\OrderController@add');
    $route->any('orderDel', 'Api\OrderController@del');
    $route->any('orderDetail', 'Api\OrderController@orderDetail');

    $route->any('tagDetail', 'Api\OrderTagController@tagDetail');
    $route->any('boxDetail', 'Api\OrderBoxController@boxDetail');
    $route->any('transportDetail', 'Api\OrderTransportController@transportDetail');
    $route->any('boxIn', 'Api\OrderBoxController@boxIn');
    $route->any('boxOut', 'Api\OrderBoxController@boxOut');
    $route->any('boxTransport', 'Api\OrderTransportController@boxTransport');
    $route->any('transportConfirm', 'Api\OrderTransportController@transportConfirm');


    $route->any('apiExport', 'Api\IOController@apiExport');



});
